select
    an.numero as "Nmero"
    , an.brincoeletronico as "Brinco eletrnico"
    , an.dtnascimento as "Data de nascimento"
    , antepenul.hrpeso as "Hora da antepenltima pesagem"
    , antepenul.observacao as "Observao antepenltima pesagem"
    , antepenul.dtpeso as "Data da antepenltima pesagem"
    , antepenul.peso as "Peso na antepenultima pesagem"
    , penult.hrpeso as "Hora da penltima pesagem"
    , penult.observacao as "Observao da penltima pesagem"    
    , penult.dtpeso as "Data da penltima pesagem"
    , penult.peso as "Peso na penltima pesagem"
    , ult.hrpeso as "Hora da ltima pesagem"
    , ult.observacao as "Observao da ltima pesagem"
    , ult.dtpeso as "Data da ltima pesagem"
    , ult.peso as "Peso na ltima pesagem"
from
  animal an
  left join peso ult on ult.cdpeso =
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal order by re.dtpeso desc)
  left join peso penult on penult.cdpeso =  
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and re.dtpeso < ult.dtpeso and re.dtpeso < ult.dtpeso order by re.dtpeso desc)
  left join peso antepenul on antepenul.cdpeso =  
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and re.dtpeso < ult.dtpeso and re.dtpeso < penult.dtpeso order by re.dtpeso desc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null

